<?php

namespace App\Exceptions;

use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Validation\ValidationException;
use Exception;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array
     */
    protected $dontReport = [
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     *
     * @return void
     */
    public function register()
    {
        $this->reportable(function (\Throwable $e) {
        });
    }

    public function render($request, \Throwable $e)
    {
        if ($e instanceof ValidationException) {
            $out = [
                'code' => 1,
                'msg'  => array_values($e->errors())[0][0],
                'data' => null,
            ];

            return response()->json($out);
        }
        $out = [
            'code' => 1,
            'msg'  => $e->getMessage(),
            'data' => null,
        ];

        return response()->json($out);
    }
}
